/*********************************************************************
 *
 *     *** HAPPy Pascal compiler ***
 *
 *          ^̏
 *
 *             void typ(Set fsys,stp **fsp,int *fsize)
 *
 *
 *                Copyright (c) H.Asano 1992
 *
 *********************************************************************/

#define EXTERN extern
#include <string.h>
#include "pascomp.h"

extern void pcerr(int,char*) ;
extern char *inttoch(long)   ;
extern Set  *orset(Set*,Set*) ;
extern Set  *mkset(Set*,int,...) ;
extern Set  *dfset(Set*,Set*) ;
extern void insymbol(void) ;
extern void skip(Set)  ;
extern ctp  *mkctp(char*,enum idclass,stp*,ctp*) ;
extern void enterid(ctp*) ;
extern ctp  *searchid(Set) ;
extern ctp  *searchsection(ctp*) ;
extern int  align(stp*,int) ;
extern boolean string(stp*) ;
extern void constant(Set, stp**, union valu*);
extern void getbounds(stp*,long*,long*) ;
extern boolean compatible(stp*,stp*) ;
extern void *Malloc(int) ;
extern void applied(ctp*,int) ;

static boolean simpletype(Set,stp**,int*) ;
static stp  *enumtype(Set) ;
static stp  *subrtype1(Set,ctp*) ;
static stp  *subrtype2(Set,ctp*) ;
static boolean complextype(Set,stp**) ;
static stp *pointertype(Set) ;
static boolean packedtype(Set) ;
static stp *recordtype(Set,boolean,boolean*);
static boolean fieldlist(Set,stp**,int*) ;
static boolean varfield(Set,stp**,int*)  ;
static boolean varelement(Set,stp*,stp**,int**);
static stp *settype(Set,boolean) ;
static stp *filetype(Set,boolean) ;
static stp *arraytype(Set,boolean,boolean*) ;

/**************************************/
/*     typ() : ^̏C         */
/**************************************/
boolean typ(Set fsys,stp **fsp,int *fsize)
{
  boolean fileflag = false ;
  Set ws ;

     if(! inset(typebegsys,sy)) {
      pcerr(10,"") ;                    /* ^̋LqɌ肪       */
      ws = fsys ;
      orset(&ws,&typebegsys) ;
      skip(ws)               ;          /* fsys+typebegsys܂œǂݔ΂ */
     }

     if(inset(typebegsys,sy)) {         /* symboltypebegsysɂ鎞 */
      if(inset(simptypebegsys,sy))      /*  P^̎                */
       fileflag = simpletype(fsys,fsp,fsize) ;/*    P^̏      */
      else
       fileflag = complextype(fsys,fsp) ;     /*  \^̏        */

     }
     else *fsp = nil  ;

     if(*fsp) {
      *fsize = (*fsp)->size ;
      (*fsp)->assignflag = !fileflag ;  /* \tOݒ         */
     }
     else *fsize = 1  ;

     return(fileflag) ;
}

/***********************************************/
/*  simpletype() :  P^̏               */
/*                                             */
/*    P^ ::= 񋓌^ | ͈͌^ | ^    */
/*      񋓌^      ::=  (O,O)        */
/*      ͈͌^  ::= 萔   .. 萔|萔  */
/*      ͈͌^  ::= 萔 .. 萔|萔  */
/*      ^        ::= O                   */
/*                                             */
/***********************************************/
static boolean simpletype(Set fsys,stp **fsp,int *fsize)
{
  stp *lsp ;
  ctp *lcp ;
  boolean fileflag = false ;
  Set ws ;

     *fsize = 1 ;
     if(! inset(simptypebegsys,sy)) {
      pcerr(1,"") ;                     /* PȌ^Ɍ肪       */
      ws = fsys ;
      orset(&ws,  &simptypebegsys) ;
      skip(ws) ;                        /* fsys+simtypebegsys܂œǂݔ΂ */
     }

     if(inset(simptypebegsys,sy)) {     /* P^̎n߂symbol̎  */
      switch(sy) {
       case  lparent  :                 /*  (                        */
         lsp = enumtype(fsys) ;         /*    񋓌^̏           */
         break         ;
       case  ident    :                 /* O                      */
         mkset(&ws, konst,types, -1) ;
         lcp = searchid(ws)          ;  /*  萔^疼OT */
         applied(lcp,level)          ;  /*  p`F[           */
         insymbol()                  ;  /*  symbolǂł   */
         if(lcp->klass == konst) {      /*  萔                   */
          lsp = subrtype1(fsys,lcp);    /*    ͈͌^1̏          */
         }
         else {                         /*  ^                     */
          lsp = lcp->idtype ;
          if(lsp) {
           *fsize = lsp->size ;
           fileflag=!(lsp->assignflag); /* \file͔]֌W*/
          }
         }
         break ;
       default :                        /*  萔                      */
         lsp = subrtype2(fsys,lcp) ;    /*    ͈͌^2̏           */
      }

      if((lsp) && (lsp->form == subrange)
         && (lsp->sf.su.rangetype) )
       if(lsp->sf.su.rangetype == realptr) /* ͈͌^̌̌^^  */
        pcerr(109,"") ;                 /* ͈͌^͎ł͑ʖ       */
       else
        if(lsp->sf.su.min > lsp->sf.su.max)
         pcerr(102,"")  ;               /* 傫       */

      if(! inset(fsys,sy)) {
       pcerr(6,"") ;                    /*  sȋLꂽ        */
       skip(fsys)  ;
      }

      *fsp = lsp ;
     }

     else *fsp = nil ;                  /* not (sy in simptypebegsys) */

     return(fileflag) ;
}

/****************************************/
/* enumtype() : 񋓌^̏            */
/*   񋓌^ := (O,O,O,)   */
/****************************************/
static stp *enumtype(Set fsys)
{
  int ttop ;
  stp *lsp ;
  ctp *lcp, *lcp1 = nil ;
  int lcnt = 0    ;                     /* eO̒lp̃JE^ */
  Set ws ;

     ttop = top  ;                      /* displaytopޔ     */
     while(display[top].occur != blck)  /* block̐T[`        */
      top-- ;
     lsp = (stp*)Malloc(sizeof(stp)) ;
     lsp->form = scalar  ;
     lsp->size = intsize ;
     lsp->sf.sc.scalkind = declared ;

     do {
      insymbol() ;
      if(sy == ident) {                 /* evf͖Oł         */
       lcp = mkctp(id,konst,lsp,lcp1) ; /* ÕGAm         */
       lcp->n.values.ival = lcnt++ ;    /* eO̒l         */
       enterid(lcp)          ;          /* Oo^                 */
       lcp1 = lcp            ;
       insymbol()            ;
      }
      else pcerr(2,"")       ;          /* OȂ                 */

      mkset(&ws,comma,rparent,-1) ;
      orset(&ws, &fsys)      ;
      if(! inset(ws,sy)) {              /* , ) fsys symbolłȂ    */
       pcerr(6,"")           ;          /*  sȋLꂽ        */
       skip(ws)              ;          /* fsys , )  ܂łœǂݔ΂ */
      }
     } while(sy == comma)    ;          /* , ŋ؂ȂΎ   */

     lsp->sf.sc.fconst = lcp1;          /* 񋓌^̍Ō̖Oւ̃|C^ */
     top = ttop              ;          /* display̐ɖ߂    */

     if(sy == rparent) insymbol() ;     /* ) Ȃ玟symbolǂ     */
     else pcerr(4,"")        ;          /*  ) Ȃ                  */

     return(lsp) ;
}

/****************************************/
/* subrtype1() : ͈͌^1̏          */
/*   ͈͌^1 := 萔..萔|萔     */
/****************************************/
static stp *subrtype1(Set fsys, ctp *lcp)
{
  stp *lsp,*lsp1 ;
  union valu lvalu ;

     lsp = (stp*)Malloc(sizeof(stp));
     lsp->form = subrange ;
     lsp->sf.su.rangetype = lcp->idtype ;
     if(string(lsp->sf.su.rangetype)) { /* 萔^ׂ     */
      pcerr(109,"")       ;             /*  ͈͌^͂̌^͏^      */
      lsp->sf.su.rangetype = nil ;
     }
     lsp->sf.su.min = lcp->n.values.ival;/* l             */
     lsp->size      = intsize ;

     if(sy == period2) insymbol()  ;    /*  .. ̎ symbolǂ*/
     else pcerr(22,"")  ;               /*  .. Ȃ                 */
     constant(fsys, &lsp1, &lvalu) ;    /*  ̏                */
     lsp->sf.su.max = lvalu.ival   ;    /*  l            */
     if(lsp->sf.su.rangetype != lsp1)
      pcerr(107,"") ;                   /* 2̌^vȂ        */

     return(lsp) ;
}

/****************************************/
/* subrtype2() : ͈͌^2̏          */
/*   ͈͌^2 := 萔..萔|萔       */
/****************************************/
static stp *subrtype2(Set fsys, ctp *lcp)
{
  stp *lsp,*lsp1 ;
  union valu lvalu ;
  Set ws ;

     lsp = (stp*)Malloc(sizeof(stp)) ;
     lsp->form = subrange            ;
     lsp->size = intsize             ;  /*  ͈͌^ƂȂ̂͐̂*/
     ws = fsys ;
     addset(ws,period2) ;
     constant(ws, &lsp1, &lvalu)     ;  /* l̏               */
     if(string(lsp1)) {
      pcerr(109,"") ;                   /* ͈͌^̌^͏^         */
      lsp1 = nil    ;
     }
     lsp->sf.su.rangetype = lsp1     ;  /* ͈͌^̌̌^             */
     lsp->sf.su.min       = lvalu.ival; /* l̐ݒ               */

     if(sy == period2) insymbol() ;     /* .. Ȃ玟symbol(l)  */
     else pcerr(22,"")            ;     /* ..łȂ .. Ȃ     */

     constant(fsys, &lsp1, &lvalu)   ;  /* l̏               */
     lsp->sf.su.max = lvalu.ival     ;  /* l̐ݒ               */

     if(lsp->sf.su.rangetype != lsp1)   /* lƉl̃^CvႤ */
      pcerr(107,"") ;                   /*  ͈͌^2̌^sv   */

     return(lsp) ;
}

/***********************************************/
/*  complextype() : P^ȊǑ^̏       */
/*                                             */
/*     ^ ^                                  */
/*      [packed]   array[P^,] of ^     */
/*      [packed]   file of ^                  */
/*      [packed]   set  of ^                  */
/*      [packed]   record ̕ end         */
/***********************************************/
static boolean complextype(Set fsys,stp **fsp)
{
  boolean packedflag ;
  boolean fileflag = false  ;

     if(sy == arrow) *fsp=pointertype(fsys)   ;         /* |C^^ */
     else {
      packedflag = packedtype(fsys) ;
      switch(sy) {
       case arraysy  : *fsp=arraytype(fsys,packedflag,&fileflag);
                       break ;                          /* z^     */
       case recordsy : *fsp=recordtype(fsys,packedflag,&fileflag);
                       break ;                          /* R[h^ */
       case setsy    : *fsp=settype(fsys,packedflag) ;  /* W^     */
                       break ;
       case filesy   : *fsp=filetype(fsys,packedflag);  /* t@C^ */
                       fileflag = true ;
      }
     }
     return(fileflag) ;
}

/**************************************/
/* pointertype() : |C^^̏   */
/**************************************/
static stp *pointertype(Set fsys)
{
  stp *lsp ;
  ctp *lcp ;
  int ttop ;
  Set ws   ;

     lsp = (stp*)Malloc(sizeof(stp)) ;  /* ^̃GA m            */
     lsp->form = pointer ;
     lsp->size = ptrsize ;
     lsp->sf.pt.eltype =  nil  ;        /* Ƃ肠nil            */

     insymbol() ;                       /* symbol(w^)   */
     if(sy == ident) {
      if(typevar) {                     /* ^`̏̎         */
       ttop = top ;
       do {                             /* ubN^T */
        lcp = searchsection(display[top].fname) ;
        if(lcp)
         if(lcp->klass == types) break ;
         else lcp = nil ;
       } while(display[top--].occur != blck);
       top = ttop ;
       if(!lcp) lcp = searchsection(display[0].fname) ;
                                        /* WT             */
       if(!lcp) {                       /* Ȃ(OQ)     */
        lcp = mkctp(id,types,lsp,fwptr);/*  OGA^Ŋmۂ*/
        fwptr       = lcp    ;          /* forward pointerɂȂ    */
       }
       else                             /*                */
        lsp->sf.pt.eltype = lcp->idtype;/*  ŵ̌^          */
      }
      else {                            /* ϐ`̏̎       */
       mkset(&ws, types, -1);
       lcp = searchid(ws)   ;           /* w^T             */
       lsp->sf.pt.eltype = lcp->idtype; /*  ŵ̌^          */
      }

      if(lsp->sf.pt.eltype)
       if(!lsp->sf.pt.eltype->assignflag)
        pcerr(608,"") ;                 /* Ǐt@C͑ʖ         */

      insymbol() ;
     }
     else pcerr(2,"") ;                 /* OȂ                 */

     return(lsp) ;
}

/**************************************/
/* arraytype() : z^̏         */
/**************************************/
static stp *arraytype(Set fsys,boolean packedflag,boolean *fileflag)
{
  stp *lsp,*lsp1,*lsp2 ;
  int lsize = 1 ;
  long range     ;
  long lmin , lmax ;
  Set ws ;
  boolean test ;

     insymbol() ;
     if(sy == lbrack) insymbol()   ;    /* [ ȂΎsymbolǂ   */
     else             pcerr(11,"") ;    /* [ łȂ [ȂG[ */

     lsp1 = nil ;
     do {
      lsp = (stp*)Malloc(sizeof(stp)) ;
      lsp->form = arrays           ;
      lsp->sf.ar.packed  = packedflag ; /* packedwL             */
      lsp->sf.ar.aeltype = lsp1    ;    /* vf̌^͑O̓Y̌^   */
      lsp->sf.ar.inxtype = nil     ;    /* Y̌^̏ݒ       */
      lsp1 = lsp ;                      /* ̃[v̂߂ɑޔ   */

      mkset(&ws, comma,rbrack,ofsy,-1) ;
      orset(&ws, &fsys) ;
      simpletype(ws,&lsp2,&lsize)  ;    /* Y̌^̏           */
      lsp->size = lsize ;               /* Y̌^̑傫         */

      if(lsp2) {
       if(lsp2->form <= subrange) {     /* Y̌^scalar,subrange*/
        if(lsp2 == realptr) {           /*  ^                    */
         pcerr(109,"") ;                /*   ł͎^͑ʖ     */
         lsp2 = nil    ;
        }
       }
       else {                           /* Y̌^scalar,subrangełȂ*/
        pcerr(113,"") ;                 /*  Y̌^̓XJ͈͌^ */
        lsp2 = nil    ;
       }
      }
      lsp->sf.ar.inxtype = lsp2 ;       /* Y̌^         */

      if(test=(sy==comma)) insymbol() ; /* , Ȃ玟symbol           */
     } while(test) ;                    /* , ȂΌJԂ           */

     if(sy == rbrack) insymbol()   ;    /* ]  Ȃ玟symbol          */
     else             pcerr(12,"") ;    /*  ] Ȃ                  */
     if(sy == ofsy)   insymbol()   ;    /* of Ȃ玟symbol          */
     else             pcerr(8,"")  ;    /*  ofȂ                  */

     *fileflag = typ(fsys,&lsp,&lsize); /* vf̌^̏             */

     do {
      lsp2 = lsp1->sf.ar.aeltype   ;    /* 1O̓Y̌^          */
      lsp1->sf.ar.aeltype = lsp    ;    /* vf̌^           */
      lsp1->assignflag=lsp->assignflag; /* \tO󂯌p   */
      if(lsp1->sf.ar.inxtype) {         /* Y̌^鎞         */
       getbounds(lsp1->sf.ar.inxtype,&lmin,&lmax) ; /* ^̍ŏ,ől*/
       range = lmax - lmin + 1     ;    /* 1̔z̑傫          */
       lsize = align(lsp,lsize) ;       /* vf̌^̃TCYE       */
       if(range &&
          ((range > (long)Maxaddr) ||
           ((long)lsize > (long)Maxaddr/range))) {
        pcerr(605,inttoch((long)Maxaddr));    /* ^̑傫       */
        lsize = 0               ;       /* Ȍ㓯G[łȂ悤 */
       }
       lsize = lsize * (int)range    ;
       lsp1->size = lsize ;             /* ̌^܂ł̃TCY */
      }
      lsp  = lsp1 ;
      lsp1 = lsp2 ;
     } while(lsp1) ;

     lsp->size = ((lsize > 1) ? lsize : 1)  ;  /* 1ȏ̃TCY̐ݒ */
     return(lsp) ;
}

/**************************************/
/* recordtype() : R[h^̏    */
/**************************************/
static stp *recordtype(Set fsys,boolean packedflag,boolean *fileflag)
{
  int oldtop ;                          /* displaytopޔĂ */
  int disp1=0;                          /* R[hΔԒn         */
  stp *lsp   ;                          /* R[h^̃|C^       */
  stp *varp  ;                          /* ϕ̌^ (Ȃnil)   */
  Set ws1    ;
  Set ws2    ;

     insymbol() ;
     oldtop = top ;                     /* displaytopޔ         */
     if(top < Displimit) {              /*  őlXgȉOK*/
      top++ ;
      display[top].fname  = nil ;       /*  Vdisplay*/
      display[top].flabel = nil ;
      display[top].aname  = nil ;
      display[top].occur  = rec ;       /*  R[h`            */
     }
     else pcerr(603,inttoch((long)Displimit)) ;
                                        /* O̓q[     */

     mkset(&ws1, endsy,-1) ;
     orset(&ws1, &fsys)    ;
     mkset(&ws2, semicolon,-1) ;        /* ws1 = fsys-[semicolon]     */
     dfset(&ws1, &ws2)     ;            /*           +[endsy]         */
     *fileflag = fieldlist(ws1,&varp,&disp1) ;
                                        /* tB[h̏           */

     lsp = (stp*)Malloc(sizeof(stp)) ;  /* R[ȟ^GAւ̐ݒ */
     lsp->form = records ;
     lsp->size = disp1   ;              /* R[h̑傫           */
     lsp->sf.re.packed = packedflag ;   /* packedwL             */
     lsp->sf.re.fstfld = display[top].fname ; /* ŏ̗̃AhX   */
     lsp->sf.re.recvar = varp ;         /* ϕ̃AhX(Ȃnil)*/

     top = oldtop ;                     /* display̐߂        */

     if(sy == endsy) insymbol() ;       /* endȂΎsymbol        */
     else pcerr(13,"") ;                /*  end Ȃ                */

     return(lsp) ;
}

/**************************************/
/* fieldlist() : R[h̗̏   */
/**************************************/
static boolean fieldlist(Set fsys,stp **frecvar,int *disp)
{
  ctp *lcp        ;
  ctp *nxt        ;
  ctp *nxt1 = nil ;
  stp *lsp  = nil ;
  int lsize       ;
  Set ws          ;
  Set ws2         ;
  boolean fileflag = false ;
  boolean test    ;

     mkset(&ws, ident, casesy, -1) ;
     orset(&ws, &fsys) ;
     if(! inset(ws,sy)) {               /* symbolfsys,ident,casełȂ*/
      pcerr(19,"") ;                    /*  ̕тɌ肪        */
      skip(ws)     ;                    /*  ǂݔ΂                  */
     }

     while(sy == ident) {               /* Œ蕔̏               */
      nxt = nxt1 ;
      do {
       if(sy == ident) {                /* O̎                   */
        lcp = mkctp(id,field,nil,nxt) ; /* OGAfieldŊm*/
        enterid(lcp) ;
        nxt = lcp ;
        insymbol() ;                    /* O̎symbol           */
       }
       else pcerr(2,"") ;               /*  OȂ                */

       mkset(&ws, comma, colon, -1) ;
       if(! inset(ws,sy)) {             /* , : łȂ               */
        pcerr(6,"")  ;                  /*  sȋLꂽ        */
        addset(ws,semicolon) ;
        addset(ws,casesy)    ;
        orset(&ws, &fsys) ;
        skip(ws)     ;                  /* ǂݔ΂                 */
       }

       if(test=(sy==comma)) insymbol(); /* , ȂΎsymbol         */
      } while(test) ;                   /* , ȂΌJԂ           */

      if(sy == colon) insymbol() ;      /* : ȂΎsymbol         */
      else pcerr(5,"") ;                /*  : Ȃ                  */

      mkset(&ws, casesy,semicolon,-1) ;
      orset(&ws, &fsys)   ;
      fileflag |= typ(ws,&lsp,&lsize) ; /* Ǒ^̏             */

      while(nxt != nxt1) {              /* O̗Ɍ^       */
       nxt->idtype = lsp ;
       *disp = align(lsp,*disp) ;
       nxt->n.fldaddr = *disp   ;       /* R[h̑ΊJnԒn   */
       if(Maxaddr-lsize < *disp)        /* 傫                 */
        pcerr(605,inttoch((long)Maxaddr));   /* ^̑傫        */
       else *disp += lsize    ;
       nxt = nxt->next   ;              /* ̖O                   */
      }
      nxt1 = lcp  ;                     /* ̌^̖O̕т̂߂ */

      mkset(&ws , ident,casesy,semicolon,-1) ;
      orset(&ws , &fsys) ;
      mkset(&ws2, ident,casesy,-1) ;
      orset(&ws2, &fsys) ;
      while(sy == semicolon) {
       insymbol() ;
       if(! inset(ws,sy)) {             /* symbolO,case,;łȂ*/
        pcerr(19,"") ;                  /*  ̕тɌ肪      */
        skip(ws2) ;                     /*  ǂݔ΂                */
       }
      }
     }

     if(sy == casesy)                   /* caseꂽ             */
      fileflag |= varfield(fsys,frecvar,disp)  ;
                                        /*   σtB[h̏     */
     else  *frecvar = nil          ;    /* casełȂΉϕ͂Ȃ */

     return(fileflag) ;
}

/**************************************/
/* varfield() : σtB[h̏  */
/**************************************/
static boolean varfield(Set fsys,stp **frecvar,int *disp)
{
  stp *lsp,*lsptag;
  ctp *lcp=nil,*lcptag  ;
  Set ws ;
  char oldid[MaxIDlng+1] ;
  enum symbol oldsy ;

     lsp = (stp*)Malloc(sizeof(stp)) ;
     lsp->form = tagfld   ;             /* ^Op̃GA           */
     lsp->sf.tg.tagfieldp = nil ;
     lsp->sf.tg.tagtype   = nil ;
     lsp->sf.tg.fstvar    = nil ;
     *frecvar = lsp       ;             /* ϕ̃^OAhXԋp */

     insymbol() ;
     if(sy == ident) {
      strcpy(oldid,id) ;
      oldsy = sy;
      insymbol() ;
      if(sy == colon) {
       lcp = mkctp(oldid,field,nil,nil) ; /* ^ÕGAm       */
       lcp->n.fldaddr = *disp ;
       enterid(lcp) ;
       insymbol()   ;
      }
      else if(sy == ofsy) {             /* of̎(^Oȗ)         */
       strcpy(id,oldid) ;
       sy = oldsy       ;               /* Oǂ񂾖O͌^         */
       oldsy = ofsy     ;
      }
      else  pcerr(5,"") ;               /*  : Ȃ                  */
      if(sy == ident) {                 /* ^                 */
       mkset(&ws, types, -1) ;
       lcptag = searchid(ws)   ;        /* ^T[`         */
       applied(lcptag,level)   ;        /* p`F[             */
       lsptag = lcptag->idtype ;        /* ^̌^                   */
       if(lsptag) {                     /* ^ꍇ               */
        *disp = align(lsptag,*disp) ;   /* ^ɓKJnԒn*/
        if(Maxaddr < *disp-lsptag->size)
         pcerr(605,inttoch((long)Maxaddr)); /* ^̑傫         */
        if(lcp)                         /* ^O鎞           */
         lcp->n.fldaddr = *disp    ;    /* ^O̕ψʂݒ         */
        *disp += lsptag->size ;         /* ̕ψʂ̂߂ɃTCYi߂*/
                                        /* ^OȂĂꏊ͊m */
        if((lsptag->form <= subrange ) &&
           (lsptag != realptr)) {       /* ^                     */
         if(lcp) lcp->idtype = lsptag ; /* ^Ǒ^AhX           */
         lsp->sf.tg.tagfieldp     = lcp    ;
         lsp->sf.tg.tagtype       = lsptag ;
        }
        else pcerr(110,"") ;            /* ^Ǒ^͏^ȊO͑ʖ */
       }
       if(oldsy != ofsy) insymbol() ;   /* of ǂ                  */
       else sy = oldsy ;                /* łofǂł鎞     */
      }
      else pcerr(2,"") ;                /* OȂ                 */
     }
     else {                             /* case̎OłȂꍇ   */
      pcerr(2,"") ;                     /*  OȂ                */
      mkset(&ws, ofsy, lparent, -1) ;
      orset(&ws, &fsys) ;
      skip(ws) ;                        /* ǂݔ΂                 */
     }

     lsp->size = *disp ;                /* ^Ô܂ł̑傫       */

     if(sy == ofsy) insymbol() ;        /* ofȂ玟symbol           */
     else pcerr(8,"") ;                 /*  ofȂ                  */

     return(varelement(fsys,lsptag,&(lsp->sf.tg.fstvar),&disp));
                                        /* ϗvf̏             */
}

/**************************************/
/* varelement() : ϗvf̏      */
/**************************************/
static boolean varelement(Set fsys,stp *fsptag,stp **fsp,int **disp)
{
  stp *lspconst,*lspfield,*lspvar=nil ;
  stp *lsp1,*lsp2,*lsp4,*lsp5,*lsp6 ;
  union valu lvalu ;
  int minsize, maxsize ,ldisp ;
  long range ;                          /* ^O^̎肦vf̍v */
  long itemsu=0;                        /* I萔̎w萔           */
  Set ws ;
  boolean fileflag = false ;
  boolean test ;
  boolean ok   ;

     range = (fsptag->form == subrange)
            ? fsptag->sf.su.max - fsptag->sf.su.min + 1  /* ͈͌^̎*/
            : fsptag->sf.sc.fconst->n.values.ival+1 ;    /* 񋓌^̎*/
     lsp1    = lsp4 = nil   ;
     maxsize = minsize = ldisp = **disp ;

     do {
      lsp2 = nil ;
      do {
       ok = false ;
       mkset(&ws, comma,colon,lparent,-1) ;
       orset(&ws, &fsys) ;
       constant(ws,&lspconst,&lvalu) ;  /* I萔                   */
       if(string(lspconst) || (lspconst==realptr)) /* ^   */
        pcerr(159,"") ;                 /* ^͎ws    */
       else if(fsptag) {                /* ^O^鎞̂݃`FbN */
        if(! compatible(fsptag,lspconst))
         pcerr(111,"")  ;               /* ǒ^ƈvĂȂ */
        else {
         ok = true ;
         if(fsptag->form == subrange)   /* ͈͌^̎             */
          if((lvalu.ival < fsptag->sf.su.min) ||  /* ŏl           */
             (lvalu.ival > fsptag->sf.su.max)) {  /* ől`FbN   */
           pcerr(111,"") ;              /* ǒ^ƈvĂȂ */
           ok = false ;
          }
         while(lsp4) {                /* dw`FbN           */
          if(lsp4->sf.vr.varval == lvalu.ival) {  /*    l      */
           pcerr(178,"") ;            /* ̂`ꂽ       */
           ok = false ;
          }
          lsp4 = lsp4->sf.vr.nextvr ;
         }
        }
       }
       if(ok) {                         /* I萔̂̎   */
        itemsu++ ;                      /*  萔̐𐔂          */
        lspvar = (stp*)Malloc(sizeof(stp));
        lspvar->form         = variant    ;
        lspvar->sf.vr.nextvr = lsp1       ;
        lspvar->sf.vr.subvar = lsp2       ;
        lspvar->sf.vr.varval = lvalu.ival ;/* I萔̒l             */
        lsp1 = lsp2 = lsp4 = lspvar ;
       }
       if(test=(sy==comma)) insymbol(); /* , ȂΎ̖D           */
      } while(test) ;
      if(sy == colon) insymbol() ;      /* : ȂΎsymbol         */
      else pcerr(5,"") ;                /*  : Ȃ                  */
      if(sy == lparent) insymbol() ;    /* ( ȂΎsymbol         */
      else pcerr(9,"") ;                /*  ( Ȃ                  */
      mkset(&ws, rparent,semicolon,-1);
      orset(&ws, &fsys) ;
      fileflag |= fieldlist(ws,&lspfield,&ldisp) ;
                                        /* tB[h̏           */
      if(ldisp > maxsize) maxsize = ldisp ;
      lsp5 = lspvar                 ;
      while(lsp5) {
       lsp6 = lsp5->sf.vr.subvar     ;
       lsp5->sf.vr.subvar = lspfield ;
       lsp5->size         = ldisp    ;
       lsp5               = lsp6     ;
      }
      if(sy == rparent) {
       insymbol() ;
       ws = fsys ;
       addset(ws,semicolon) ;
       if(! inset(ws,sy)) {
        pcerr(6,"") ;                   /*  sȋLꂽ        */
        skip(ws)    ;                   /*  fsys+[semicolon]܂œǂݔ΂*/
       }
      }
      else pcerr(4,"") ;                /*  ) Ȃ                  */
      if(sy == semicolon) {
       ldisp = minsize ;
       insymbol() ;
      }
     } while(! inset(fsys,sy)) ;        /* ; end fsys łȂ΃[v*/

     if(itemsu != range) pcerr(179,"") ;/* ^O^Ŏ肦邷ׂĂ̑I萔
                                           w肳ĂȂ              */
     *fsp   = lspvar  ;
     **disp = maxsize ;
     return(fileflag) ;
}

/**************************************/
/* settype() : W^̏           */
/**************************************/
static stp *settype(Set fsys,boolean packedflag)
{
  stp *lsp, *lsp1 ;
  int lsize = 1 ;
  long lmin , lmax ;

     insymbol() ;
     if(sy == ofsy) insymbol() ;        /* of Ȃ玟symbol          */
     else pcerr(8,"")          ;        /*  ofȂ                  */

     simpletype(fsys,&lsp1,&lsize) ;    /* ̌^͒P^           */

     if(lsp1) {
      if((lsp1->form > subrange) ||     /* scalar,͈͌^ł͂Ȃ      */
          (lsp1 == realptr)) {          /* ^                     */
       pcerr(115,"")  ;                 /*  ̌^^łȂ@  */
       lsp1 = nil     ;
      }
      else {                            /* 񋓌^͈͌^̎          */
       getbounds(lsp1,&lmin,&lmax) ;    /* ^̍ŏlől߂  */
       if((lmin < (long)setlow) ||
          ((long)sethigh < lmax))       /* W̗vf`FbN       */
        pcerr(606,inttoch((long)sethigh)) ;/*  ^͈͉̏z */
      }
     }

     lsp = (stp*)Malloc(sizeof(stp)) ;
     lsp->form = power       ;          /* W^                     */
     lsp->size = setsize     ;          /* W̑傫               */
     lsp->sf.pw.packed= packedflag ;    /* packedwL             */
     lsp->sf.pw.elset = lsp1 ;          /* vf̌^                   */
     lsp->sf.pw.elmin = (int)lmin ;     /* vf̍ŏl               */
     lsp->sf.pw.elmax = (int)lmax ;     /* vf̍ől               */
     return(lsp)             ;
}

/**************************************/
/* filetype() : t@C^̏      */
/**************************************/
static stp *filetype(Set fsys,boolean packedflag)
{
   stp *lsp,*lsp1 ;
   int lsize ;
   boolean fileflag ;

     insymbol()    ;
     if(sy == ofsy) insymbol() ;
     else pcerr(8,"") ;                 /* of Ȃ                  */
     fileflag = typ(fsys,&lsp1,&lsize) ;/* ̌^̏             */
     if(fileflag) pcerr(112,"") ;       /* \Ȍ^łȂ         */

     lsp = (stp*)Malloc(sizeof(stp)) ;
     lsp->form = files ;                /* t@C^                 */
     lsp->size = lsp1->size ;           /* ̌^̑傫           */
     lsp->sf.fi.packed = packedflag ;   /* packedwL             */
     lsp->sf.fi.texttype = false    ;   /* file of `  text^łȂ */
     lsp->sf.fi.filtype  = lsp1     ;   /* ̌^                   */

     return(lsp) ;
}

/**************************************/
/* packedtype() : packed ̏       */
/**************************************/
static boolean packedtype(Set fsys)
{
  boolean packedflag ;                  /* packed w̎ true       */
  Set ws ;

     if(packedflag=(sy == packedsy)) {  /* packed̋Lq鎞       */
      insymbol() ;                      /* symbolǂ           */
      if(! inset(typedels,sy)) {        /*  array,record,set,fileȊO */
       pcerr(10,"")  ;                  /*   ^̋LqɌ肪     */
       ws = fsys ;
       orset(&ws,&typedels) ;
       skip(ws)  ;                      /* fsys+typedles܂œǂݔ΂*/
      }
     }
     return(packedflag) ;
}
